<h2>Похожие статьи:</h2>
<?php sp_related_posts(get_the_ID()); ?>


<?php

/* 
 * функция нахождения похожих статей
 *
 * @param integer $id - идентификатор анализируемого поста
 */
function sp_related_posts($id){
    global $wpdb;

    $countArticle = 4;  // количество похожих статей
    $isDescription = false;  // описание для каждой статьи
    $descriptionLen = 200;  // если включено описание, то какой длинные его делать
    
    $countWords = 6;    // количество слов в конечном итоге для анализа
    $minLengthWord = 3; // минимальная длинна анализируемого слова, остальные отсеиваются
    $factorTitle = 0.2; // эмпирический коэффициент участвующий в расчёте веса слов из заголовка
    $factorText = 0.9;  // эмпирический коэффициент участвующий в расчёте веса слов из текста
    $stopWords = array('они', 'том', 'тот', 'обо', 'она', 'три', 'без', 'ста', 'сто', 'них', 'там', 'тем', 'тут', 'оба', 'той', 'оно', 'под', 'сам', 'чьё', 'эта', 'эти', 'про', 'ней', 'это', 'чье', 'ото', 'ним', 'час', 'при', 'чей', 'чем', 'чья', 'что', 'уже', 'всю', 'ему', 'его', 'для', 'два', 'еще', 'ещё', 'изо', 'ибо', 'нет', 'год', 'где', 'вас', 'вам', 'был', 'вне', 'вот', 'вся', 'всё', 'все', 'или', 'эту', 'мой', 'мог', 'мне', 'так', 'над', 'нам', 'неё', 'нее', 'наш', 'нас', 'кто', 'мои', 'как', 'раз', 'моя', 'буду', 'этой', 'свое', 'тема', 'того', 'темы', 'тему', 'теме', 'твой', 'себе', 'этом', 'чуть', 'тебя', 'чтоб', 'куда', 'свою', 'чего', 'хотя', 'хоть', 'часу', 'этот', 'тоже', 'меня', 'могу', 'либо', 'ином', 'иной', 'надо', 'него', 'пять', 'сами', 'оный', 'один', 'ноль', 'есть', 'если', 'быть', 'ведь', 'было', 'были', 'была', 'весь', 'вниз', 'день', 'даже', 'всех', 'всей', 'свой', 'лишь', 'себя', 'семь', 'стал', 'из-за', 'кроме', 'можно', 'какой', 'через', 'таких', 'разве', 'когда', 'лучше', 'какое', 'потом', 'может', 'такою', 'такую', 'такие', 'перед', 'таком', 'также', 'между', 'вдоль', 'много', 'такое', 'точно', 'стали', 'стать', 'будем', 'давай', 'среди', 'всего', 'стала', 'видно', 'тогда', 'внизу', 'давно', 'сразу', 'здесь', 'знать', 'иметь', 'назад', 'зачем', 'таким', 'долго', 'такой', 'будут', 'такая', 'снова', 'тысяч', 'самим', 'опять', 'около', 'чтобы', 'после', 'самой', 'темою', 'будет', 'будто', 'редко', 'шесть', 'самая', 'часто', 'очень', 'темой', 'жизнь', 'самый', 'пусть', 'темам', 'вдруг', 'самым', 'этого', 'прямо', 'некто', 'никто', 'равно', 'какая', 'темах', 'почти', 'более', 'только', 'четыре', 'самому', 'десять', 'вместо', 'будете', 'теперь', 'девять', 'далеко', 'всегда', 'будешь', 'ребята', 'восемь', 'внутри', 'вокруг', 'давать', 'похоже', 'однако', 'иногда', 'такого', 'ничего', 'сказал', 'хорошо', 'нельзя', 'тысячу', 'тысячи', 'темами', 'тысяча', 'такому', 'больше', 'отчего', 'почему', 'потому', 'совсем', 'сейчас', 'другие', 'именно', 'другой', 'нибудь', 'каждым', 'такими', 'другое', 'каждый', 'большой', 'каждому', 'которые', 'конечно', 'человек', 'сначала', 'каждого', 'впрочем', 'кажется', 'никогда', 'сказали', 'сказать', 'недавно', 'сегодня', 'который', 'говорил', 'говорят', 'спасибо', 'говорим', 'другого', 'наконец', 'сказала', 'особенно', 'говорили', 'навсегда', 'говорить', 'которого', 'несколько', 'достаточно', 'пожалуйста');
    $stopSymbols = array('—', '–', '_', '"', '‘', '’', '‚', '“', '”', '„', '"', 'x27', 'x22', 'x60', '\t', '\n', '\r', '\'', ',', '.', '/', '\\', '«', '»', '#', ';', ':', '@', '~', '[', ']', '{', '}', '=', '-', '+', ')', '(', '*', '&', '^', '%', '$', '<', '>', '?', '!');

    $post = get_post($id);
    $title = $post->title;
    $text = $post->post_content;

    $text = strip_tags($title.' '.$text);
    // вначале убираем все стоп-символы и лишние пробелы из текста
    foreach ($stopSymbols as $symbol)
            $text = str_replace($symbol, ' ',$text);
    // переводим текст в массив, разделяя элементы пробелом
    $text = explode(' ', mb_strtolower(trim($text)));
    // убираем все стоп-слова
    $text = array_diff($text, $stopWords);
    // считаем частоту повторения каждого слова
    $text = array_count_values($text);
    arsort($text);
    $text = array_keys($text);
    // убираем окончания
    $words=array();
    foreach($text as $word) {
        if (strlen($word) >= $minLengthWord) {  // оставляем слова только длинной больше $minLengthWord
            // От слов длиннее 7 символов отрезать 2 последних буквы
            if (strlen($word) > 7) {
                $word=substr($word,0,(strlen($word)-2));
            }
            // От слов длиннее 5 символов отрезать последнюю букву
            elseif (strlen($word) > 5) {
                $word=substr($word,0,(strlen($word)-1));
            }
            $words[]=addcslashes(addslashes($word),'%_');
        }
    }
    
    $words = array_slice($words, 0, $countWords);
     
    $where = "";
    $select = "(";
    // Условия для каждого из слов
    foreach($words as $word) {
        $select .= "IF (post_title LIKE '%".$word."%', ".$factorTitle.", 0) + IF (post_content LIKE '%".$word."%', ".$factorText.", 0) + ";
        $where .= "post_title LIKE '%".$word."%' OR post_content LIKE '%".$word."%' OR ";
    }
    $select = substr($select, 0, -2);   // убираем последние два символа (плюсик и пробел)
    $select.=") AS relevant";
    $where = substr($where, 0, -3); // убираем последние три символа (OR и пробел)

    $results = $wpdb->get_results('
        SELECT
            ID, post_title, '.($isDescription?'post_content, ':'').$select.'
        FROM
            '.$wpdb->posts.'
        WHERE
            ('.$where.' ) AND post_status = "publish" AND post_type = "post" AND ID <> '.$id.'
        ORDER BY
            relevant DESC
        LIMIT '.$countArticle
    );
    
    if (!empty($results)) {
        $return = '<div class="related-posts"><ul>';
        foreach($results as $result){
            $return .= '<li><a title="'.$result->post_title.'" href="'.get_permalink($result->ID).'">'.get_the_post_thumbnail( $result->ID, 'related-size' ).mb_substr($result->post_title, 0, 22).'...</a>';
            if ($isDescription and $descriptionLen > 0 and $result->post_content) { // если описание для статей нужно, то вставляем его убрав лишние теги сократив до нужной длинны до пробела
                $descriptionSrc = strip_tags($result->post_content);
                $len = (mb_strlen($descriptionSrc) > $descriptionLen)
                    ? mb_strripos(mb_substr($descriptionSrc, 0, $descriptionLen), ' ')
                    : $descriptionLen
                ;
                $description = mb_substr($descriptionSrc, 0, $len);
                $description = (mb_strlen($descriptionSrc) > $descriptionLen)
                    ? $description . '...'
                    : $description
                ;
                
                $return .= ' - <span class="post-description">'.$description.'</span>';
            }
            $return .= '</li>';
        }
        $return .= '</ul></div>';
        echo $return;
    }
}
